package dk.aau.cs.model.tapn.Colored.Expressions;

import dk.aau.cs.model.tapn.Colored.Multiset;
import dk.aau.cs.model.tapn.Colored.Variable;

import java.util.Set;

public class ScalarProductExpression extends ArcExpression {

    private Integer scalar;
    private ArcExpression expr;

    public ScalarProductExpression(Integer scalar, ArcExpression expr) {
        this.scalar = scalar;
        this.expr = expr;
    }

    //Missing implementation for evaluation - might not be needed
    public Multiset eval(ExpressionContext context) {
        return null;
    }

    public void expressionType() {

    }

    public Integer weight() {
        return scalar * expr.weight();
    }

    public void getVariables(Set<Variable> variables) {
        expr.getVariables(variables);
    }

    public String toString() {
        return scalar.toString() + " * " + expr.toString();
    }
}
