package dk.aau.cs.model.tapn.Colored.Expressions;

import dk.aau.cs.model.tapn.Colored.Color;
import dk.aau.cs.model.tapn.Colored.Variable;

import java.util.Set;

public class VariableExpression extends ColorExpression {

    private Variable variable;

    public VariableExpression(Variable variable) {
        this.variable = variable;
    }

    public Color eval(ExpressionContext context) {
        return context.binding.get(variable.getName());
    }

    public void getVariables(Set<Variable> variables) {
        variables.add(variable);
    }
}
