package dk.aau.cs.model.tapn;

import dk.aau.cs.model.tapn.event.TimedPlaceListener;
import dk.aau.cs.util.Tuple;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

public class LocalColoredPlace extends TimedPlace {

    private static final Pattern namePattern = Pattern.compile("^[a-zA-Z_][a-zA-Z0-9_]*$");

    private String name;
    private String text;
    private String cyclicEnumID;

    private TimedArcPetriNet model;
    private TimedMarking currentMarking;
    private List<TimedPlaceListener> listeners = new ArrayList<TimedPlaceListener>();

    private Tuple<PlaceType, Integer> extrapolation = new Tuple<TimedPlace.PlaceType, Integer>(PlaceType.Dead, -2);

    public LocalColoredPlace(String name, String text, String cyclicEnumID) {
        this.name = name;
        this.text = text;
        this.cyclicEnumID = cyclicEnumID;
    }

    public TimedArcPetriNet model() {return model;}

    public void addTimedPlaceListener(TimedPlaceListener listener) {

    }

    public void removeTimedPlaceListener(TimedPlaceListener listener) {

    }

    public boolean isShared() {
        return false;
    }

    public String name() {
        return null;
    }

    public void setName(String newName) {

    }

    public TimeInvariant invariant() {
        return null;
    }

    public void setInvariant(TimeInvariant invariant) {

    }

    public List<TimedToken> tokens() {
        return null;
    }

    public int numberOfTokens() {
        return 0;
    }

    public void setCurrentMarking(TimedMarking marking) {

    }

    public void addToken(TimedToken timedToken) {

    }

    public void addTokens(Iterable<TimedToken> tokens) {

    }

    public void removeToken(TimedToken timedToken) {

    }

    public void removeToken() {

    }

    public Tuple<PlaceType, Integer> extrapolate() {
        return null;
    }

    public TimedPlace copy() {
        return null;
    }
}
