package dk.aau.cs.model.tapn.Colored.Expressions;

import dk.aau.cs.model.tapn.Colored.Multiset;
import dk.aau.cs.model.tapn.Colored.Variable;

import java.util.Set;
import java.util.Vector;

public class AddExpression extends ArcExpression {

    private Vector<ArcExpression> constituents;

    public AddExpression(Vector<ArcExpression> constituents) {
        this.constituents = constituents;
    }

    //Missing implementation for evaluation - might not be needed
    public Multiset eval(ExpressionContext context) {
        return null;
    }

    public void expressionType() {

    }

    public Integer weight() {
        Integer res = 0;
        for (ArcExpression element : constituents) {
            res += element.weight();
        }
        return res;
    }

    public void getVariables(Set<Variable> variables) {
        for (ArcExpression element : constituents) {
            element.getVariables(variables);
        }
    }

    public String toString() {
        String res = constituents.get(0).toString();
        for (int i = 1; i < constituents.size(); ++i) {
            res += " + " + constituents.get(i).toString();
        }
        return res;
    }
}
