package dk.aau.cs.model.tapn.Colored.Expressions;

import dk.aau.cs.model.tapn.Colored.Color;
import dk.aau.cs.model.tapn.Colored.Variable;

import java.util.Set;
import java.util.Vector;

public class TupleExpression {
    private Vector<ColorExpression> colors;

    public  TupleExpression(Vector<ColorExpression> colors) {
        this.colors = colors;
    }

    //Missing implementation for evaluation - might not be needed
    public Color eval(ExpressionContext context) {
        return null;
    }

    public void getVariables(Set<Variable> variables) {
        for (ColorExpression element : colors) {
            element.getVariables(variables);
        }
    }

    public String toString() {
        String res = "(" + colors.get(0).toString();
        for (int i = 1; 1 < colors.size(); ++i) {
            res += "," + colors.get(i).toString();
        }
        res += ")";
        return res;
    }
}
